/*****************************************************************/
/*                                                               */
/*   picalc ver 1.30                                             */
/*                                                               */
/*   written by sentaro21                                        */
/*                                                               */
/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "fxlib.h"
#include "fx_syscall.h"
#include "TIMER_FX2.H"


//------------------------------------------------------------------------------
int KeyCheckAC(void)		// [AC]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
	}
 	return flag0;
}

int KeyCheckEXE(void)		// [EXE]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
	}
 	return flag0;
}

int KeyCheckPlusMinus(void)	// (-)
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 2 ) ) flag0=1; // [(-)] is down
	}
 	return flag0;
}


//----------------------------------------------------------------------------------------------

int InputNumL(int x, int y, int width, int defaultNum) {		// 012345
	int i,j;
	char buffer[22];
	char buffer2[22];
	unsigned int key=0;
	int csrX=0,numX=0;
	int cont=1;

	sprintf(buffer,"%d",defaultNum);
	csrX=strlen(buffer); numX=csrX;
	buffer[csrX]=' ';
	for(i=csrX+1; i<=width; i++) buffer[i]=' ';
	buffer[width+1]='\0';
	
	Cursor_SetFlashMode(1);			// cursor flashing on
	if (Cursor_GetFlashStyle()<0x6) {
		Cursor_SetFlashStyle(0);	// insert mode cursor 
		Cursor_SetFlashOn(0);
		}
		else {
		Cursor_SetFlashStyle(0x10);	// overwrite mode cursor 
		Cursor_SetFlashOn(0x6);	
	}

	while (cont) {
		locate(x       ,y); Print(   (unsigned char*)buffer);
//		locate(x,y+1); sprintf(buffer2,"%d %d  S=%d",csrX,numX,Cursor_GetFlashStyle()); Print(   (unsigned char*)buffer2);
		Cursor_SetPosition(x+csrX-1,y-1);
	
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_AC:
				csrX=0; numX=0;
				for(i=csrX; i<=width; i++) buffer[i]=' ';
				break;
			case KEY_CTRL_EXIT:
				cont=0; return -1 ;
				break;
			case KEY_CTRL_EXE:
				cont=0;
				break;
			case KEY_CTRL_DEL:
				if (csrX==0) {
					if (numX>0) {
						for(i=csrX; i<numX; i++) buffer[i]=buffer[i+1];
						numX--;
					}
				}
				if (csrX>0) {
					if (Cursor_GetFlashStyle()<0x6) {	// insert mode
						for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
						csrX--;
						numX--;
					}
					else {								// overwrite mode
						if (csrX==numX) {
							for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
							csrX--;
							numX--;
						}
						else {
							for(i=csrX  ; i<width; i++) buffer[i]=buffer[i+1];
							numX--;
						}
					}
				}
				break;
			case KEY_CTRL_LEFT:
				if (csrX>0) {
					csrX--;
				}
				break;
			case KEY_CTRL_RIGHT:
				if (csrX<numX) {
					csrX++;
				}
				break;
			default:
				break;
		}
		if ( ( KEY_CHAR_0 <= key ) && ( key <= KEY_CHAR_9 ) ) {
				if (csrX<width) {
					if (csrX<numX) {
						if (Cursor_GetFlashStyle()<0x6) {
							if (numX<width) {		// insert mode
								for(i=width; i>csrX; i--) buffer[i]=buffer[i-1];
								buffer[csrX]=key;
								numX++;
								csrX++;
							}
						}
						else {				// overwrite mode
								buffer[csrX]=key;
								csrX++;
						}
					}
					else {					// new
						buffer[csrX]=key;
						csrX++; if (csrX>numX) numX=csrX;
					}
				}
		}
	}

	Cursor_SetFlashMode(0);

	return (atoi(buffer));
}


void InputTest(){
	int i,j;
	char buffer[21];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"Input=");

	i=InputNumL(7,1,9,123);
	
	locate(1,3);sprintf(buffer,"  num=%d",i); Print((unsigned char*)buffer);

	GetKey(&key);
}


int InputDigits(int x, int y, int Digits, int Limit) {
	char buffer[21];
	locate(x,y); Print((unsigned char*)"Digits=");
	locate(x+15,y); sprintf(buffer,"<%d",Limit); Print((unsigned char*)buffer);
	loop:
		Digits=InputNumL(x+7,y,4,Digits);
		if ( Digits<   0)  { return -1 ; }
		if ( Digits<  10)  { Digits=  10 ; goto loop; }
		if ( Digits>Limit) { Digits=Limit; goto loop; }
	locate(x+7,y); sprintf(buffer,"%d   ",Digits); Print((unsigned char*)buffer);
	return ( Digits );
}

int InputBaseDigits(int x, int y, int BaseDigits, int Limit) {
	char buffer[21];
	locate(x,y); Print((unsigned char*)"Base=");
	locate(x+15,y); sprintf(buffer,"<%d",Limit); Print((unsigned char*)buffer);
	loop:
		BaseDigits=InputNumL(x+5,y,2,BaseDigits);
		if ( BaseDigits< 0 )    { return -1 ; }
		if ( BaseDigits< 1 )    { BaseDigits= 2;    goto loop; }
		if ( BaseDigits>Limit) { BaseDigits=Limit; goto loop; }
	locate(x+5,y); sprintf(buffer,"%d  ",BaseDigits); Print((unsigned char*)buffer);
	return ( BaseDigits );
}


//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------ double version

//double  P[201];		// result   10 Digits/array
int skip_count;

#define ARRYSd  501

double  L4d[ARRYSd];

void Pack10str(char*buffer,int i, int Digits, int BaseDigits, int m) {
										// -> pack to 10 digits string
	int	j,n,c,d,w,x,q;
	double r,p;

	p=0;
	n=10;
	c=10*i+m;
	j=c/BaseDigits+1-m;
	q=(j-1+m)*BaseDigits;
	while (n>0) {
		w=BaseDigits-c+q;
		j++;
		r=L4d[j]-floor(L4d[j]/pow(10,w))*pow(10,w);
		d=w;
		if (d>n) d=n;
		n=n-d;
		p=p+floor(r/pow(10,w-d))*pow(10,n);
		c=c+d;
		q=q+BaseDigits;
	}
	
	sprintf(buffer,"%010.0f",p);

	c=10*i;
	if ( (0<(Digits-c)) && ((Digits-c)<10) ) { n=10-(Digits-Digits/10*10);}
	if ( c>=Digits ) n=10;

	for(j=10-n; j<10; j++) buffer[j]='*';

	return;
}


void disp_d(int t, int Digits,  int arrys, int BaseDigits, int m){
	int i,j;
	char buffer[21];
	unsigned int key=0;
	
	Bdisp_AllClr_DDVRAM();
	locate( 1,1);sprintf(buffer,"PI=%1.0f.",3.0); Print((unsigned char*)buffer);

	locate(1,7);sprintf(buffer,"time=%5.2fs",(float)t/128); Print((unsigned char*)buffer);
	locate(1,8); Print((unsigned char*)"Hit <AC> RET");
	Bdisp_PutDisp_DD();
	
	i=0;
	while ( 1 )  { 
		if ( key == KEY_CTRL_EXE  ) break;		// [EXE]
		if ( key == KEY_CTRL_AC   ) return;		// [AC]
		if ( key == KEY_CTRL_EXIT ) return;		// [EXIT]
		if ( key == KEY_CTRL_UP )   if ( i>=2 )                    i-= 2; 
		if ( key == KEY_CTRL_DOWN ) if ( ((i+ 0)*10+100)< Digits ) i+= 2; 
		if ( key == KEY_CTRL_LEFT ) if ( i>=10 )                   i-=10; 
		if ( key == KEY_CTRL_RIGHT) if ( ((i+ 0)*10+100)< Digits ) i+=10; 

		locate(6,1); sprintf(buffer,"(%4d-%4d)/%d ",i*10+1,i*10+100,Digits); Print((unsigned char*)buffer);
		for(j=0; j<5; j++){
			Pack10str(buffer, 0+i+j*2,Digits,BaseDigits,m); locate( 1,2+j); Print((unsigned char*)buffer);
			Pack10str(buffer, 1+i+j*2,Digits,BaseDigits,m); locate(12,2+j); Print((unsigned char*)buffer);
		}	
		GetKey(&key);
	}
}

int disp_wait(int a, int b, int s,int t) {
	char buffer[21];
	unsigned int key=0;
	
		if ( RTC_GetTicks() > skip_count+24 ) { skip_count=RTC_GetTicks();
			t=RTC_GetTicks()-s;
			locate(1,5); sprintf(buffer, "C=%4d/%4d", a, b);			Print((unsigned char*)buffer);
			locate(1,6); sprintf(buffer, "time=%5.2fs", (double)t/128);	Print((unsigned char*)buffer);
			Bdisp_PutDisp_DD();
			if ( KeyCheckPlusMinus() ) {
				locate(1,7); Print((unsigned char*)"EXE:Start");
				while ( 1 )  { GetKey(&key);
					if ( key == KEY_CTRL_EXE  ) {				// [EXE]
							locate(1,7); Print((unsigned char*)"(-):Stop ");
							s=RTC_GetTicks()-t; return s; }
					if ( key == KEY_CTRL_AC   ) return 0;		// [AC]
					if ( key == KEY_CTRL_EXIT ) return 0;		// [EXIT]
				}	
			}	
			if ( KeyCheckAC() ) return 0;
		}
	return s;
}

//------------------------------------------------------------------------------ double version 1

void PICALC_d()
{
	int Digits,BaseDigits;
	double n, f, g, w, temp, cy, base;
	int i, j, s, t,arrys;

	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PI DBL calculation");
	Digits=InputDigits(1,2, 1000, 5000);
	if (Digits<0) return;
	BaseDigits=InputBaseDigits(1,3, 10, 15);
	if (BaseDigits<0) return;
	arrys=(Digits+BaseDigits-1)/BaseDigits+1;
	if (ARRYSd<arrys-1) goto ERR;
	
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();

	base=pow(10,BaseDigits);
	skip_count=0;
	
  	//  array initialize
	for(i=0;i<=arrys;i++) {
		L4d[i]=0;
	}

	s=RTC_GetTicks();	// --------------------------------------

  	//  loop counter
  	n = log(10)/log(2)*Digits+1 ;

	j=0;
  	for(f=floor(n);f>0;f--) {

	    //  A * f -> B
	    cy = 0;
		for(i=arrys; i>0; i--) {
	    	w = L4d[i]*f + cy;
	    	cy = floor(w/base);
	    	L4d[i] = w - cy*base;
	  	}

	    //  A / (f*2+1) -> B
	    g=f*2+1;
	  	for(i=1; i<=arrys; i++) {
			temp = cy*base + L4d[i];
	    	w = floor(temp / g);
	    	cy = temp - w*g;
	    	L4d[i] = w;
		}

	    //  A + 2 -> A
	    L4d[1] = L4d[1]+2;
	    
		s=disp_wait((int)(floor(n)-f+1), (int)floor(n), s, t);
		if (s==0) return;

	};

	t=RTC_GetTicks()-s;	// --------------------------------------

	disp_d(t, Digits, arrys, BaseDigits, 0);
}

//------------------------------------------------------------------------------ double version 2

//  L4(A) -> L4(B)
void adjust_A_f_d(int arrys, double base)
{
	int i;
	double w;
  	double cy = 0;

  	for(i=arrys; i>0; i--) {
		w = L4d[i] + cy ;
		cy = floor(w / base) ;
		L4d[i] = w - cy*base ;
  	}
}


void PICALC2_d()
{
	int Digits,BaseDigits;
	double n, f, g, w, temp, cy, base;
	int i, j, s, t, arrys;

	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PI DBL calculation 2");
	Digits=InputDigits(1,2, 1000, 5000);
	if (Digits<0) return;
	BaseDigits=InputBaseDigits(1,3, 10, 15);
	if (BaseDigits<0) return;
	arrys=(Digits+BaseDigits-1)/BaseDigits+1;
	if (ARRYSd<arrys-1) goto ERR;
	
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();

	base=pow(10,BaseDigits);
	skip_count=0;
	
  	//  array initialize
	for(i=0;i<=arrys;i++) {
		L4d[i]=0;
	}
	
	s=RTC_GetTicks();	// --------------------------------------

  	//  loop counter
  	n = log(10)/log(2)*Digits+1 ;

  	for(f=floor(n);f>0;f--) {

	    //  A * f / (f*2+1) -> B
	    g=f*2+1;
	    cy = 0;
		for(i=1; i<=arrys; i++) {
			temp = L4d[i] * f + cy*base ;
    		w = floor(temp / g) ;
    		cy = temp - w*g ;
    		L4d[i] = w ;
		}

	    //  A + 2 -> A
	    L4d[1] = L4d[1]+2;
	    
		s=disp_wait((int)(floor(n)-f+1), (int)floor(n), s, t);
		if (s==0) return;

	};
	
	adjust_A_f_d(arrys,base);

	t=RTC_GetTicks()-s;	// --------------------------------------

	disp_d(t, Digits, arrys, BaseDigits, 0);
}


//------------------------------------------------------------------------------ double version 3

void PICALC3_d()
{
	double  y[3400];

	int Digits,BaseDigits;
	double n, w, temp, c, base, g;
	int i, j, e, f, s, t, arrys;
	int skip_count=0;
	
	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PI DBL calculation 3");
	Digits=InputDigits(1,2, 1000, 1000);
	if (Digits<0) return;
	BaseDigits=InputBaseDigits(1,3, 7, 15);
	if (BaseDigits<0) return;
	arrys=Digits/BaseDigits+1;
	if (ARRYSd<arrys-1) goto ERR;
	
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();

	base=pow(10,BaseDigits);
	skip_count=0;
	
  	//  array initialize
//	for(i=0;i<ARRYSd;i++) {
//		L4d[i]=0;
//	}
	
	s=RTC_GetTicks();	// --------------------------------------

  	//  loop counter
  	e = floor(log(10)/log(2)*BaseDigits);
  	f = floor(log(10)/log(2)*(Digits+1))+1;

	for(i=0;i<=f;i++) {
		y[i]=base/5;
	}

	c=0;
	n=f;
  	for(i=1; i<=arrys; i++) {
		temp=0;
		for(j=n-1; j>0; j--) {
			g=(double)2*j-1;
			w=temp*j+(double)y[j]*base;
			temp=floor(w/g);
			y[j]=(double)(w-temp*g);
		}

		w=floor(temp/base);
		L4d[i]=c+w;
		c=temp-w*base;

		n=n-e;
	    
		s=disp_wait((int)(floor(n)), (int)floor(f), s, t);
		if (s==0) return;

	};
	
	adjust_A_f_d(arrys,base);

	t=RTC_GetTicks()-s;	// --------------------------------------

	disp_d(t, Digits, arrys, BaseDigits, 1);
}



//----------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------ int version

#define ARRYS   650

int  L4[ARRYS];

//------------------------------------------------------------------------------ int version 1


//  div L4(A)/f -> L4(B)
void div_A_f(int arrys, int f, int base)
{
  	int i,w,t;
  	int cy = 0;

}

//  mul L4(A)*f -> L4(B)
void mul_A_f(int arrys, int f, int base)
{
	int i;
	int w;
  	int cy = 0;

}

void PICALC()
{
	int Digits,BaseDigits;
	int n, f, g, w, cy, base;
	int i, j, s, t, arrys;
	
	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PI calculation");
	Digits=InputDigits(1,2, 1000, 2500);
	if (Digits<0) return;
	BaseDigits=InputBaseDigits(1,3, 5, 5);
	if (BaseDigits<0) return;
	arrys=(Digits+BaseDigits-1)/BaseDigits+1;
	if (ARRYS<arrys-1) goto ERR;
	
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();

	base=(int)pow(10,BaseDigits);
	skip_count=0;

  	//  array initialize
	for(i=0;i<=arrys;i++) {
		L4[i]=0;
	}

	s=RTC_GetTicks();	// --------------------------------------

  	//  loop counter
  	n = log(10)/log(2)*Digits+1 ;

  	for(f=n;f>0;f--) {

	    //  A * f -> B
	    cy = 0;
	  	for(i=arrys; i>0; i--) {
	    	w = L4[i]*f + cy;
	    	cy = (w/base);
	    	L4[i] = w-cy*base;
	  	}

	    //  A / f -> B
	    g = f*2+1;
	  	for(i=1; i<=arrys; i++) {
			t = cy*base + L4[i];
	    	w = (t / g);
	    	cy = t - w*g;
	    	L4[i] = w;
		}

	    //  A + 2 -> A
	    L4[1] = L4[1]+2;

		s=disp_wait(n-f+1, n, s, t);
		if (s==0) return;

	};

	t=RTC_GetTicks()-s;	// --------------------------------------

	for(i=1; i<=arrys; i++){
		L4d[i]=(double)L4[i*2-2]*(double)base+(double)L4[i*2-1];
	}
	
	disp_d(t, Digits, arrys, BaseDigits*2, 0);

}

//------------------------------------------------------------------------------ int version 2

//  div L4(A)/f -> L4(B)
void mul_div_A_f(int arrys, int f, int base)
{
  	int i,w,t;
  	int cy = 0;
  	int g=f*2+1;

  	for(i=1; i<=arrys; i++) {
		t = L4[i] * f + cy*base ;
    	w = (t / g) ;
    	cy = t - w*g ;
    	L4[i] = w;
	}
}

//  L4(A) -> L4(B)
void adjust_A_f(int arrys, int base)
{
	int i;
	int w;
  	int cy = 0;

  	for(i=arrys; i>0; i--) {
		w = L4[i] + cy ;
		cy = w / base ;
		L4[i] = w - cy*base;
  	}
}


void PICALC2()
{
	int Digits,BaseDigits;
	int n, f, w, base;
	int i, j, s, t, arrys;
	
	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PI calculation 2");
	Digits=InputDigits(1,2, 1000, 2500);
	if (Digits<0) return;
	BaseDigits=InputBaseDigits(1,3, 5, 5);
	if (BaseDigits<0) return;
	arrys=(Digits+BaseDigits-1)/BaseDigits+1;
	if (ARRYS<arrys-1) goto ERR;
	
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();

	base=(int)pow(10,BaseDigits);
	skip_count=0;

  	//  array initialize
	for(i=0;i<=arrys;i++) {
		L4[i]=0;
	}

	s=RTC_GetTicks();	// --------------------------------------

  	//  loop counter
  	n = log(10)/log(2)*Digits+1 ;

  	for(f=n;f>0;f--) {

	    //  A * f / (f*2+1) -> B
	    mul_div_A_f(arrys,f,base);

	    //  A + 2 -> A
	    L4[1] = L4[1]+2;

		s=disp_wait(n-f+1, n, s, t);
		if (s==0) return;

	};

	adjust_A_f(arrys,base);

	t=RTC_GetTicks()-s;	// --------------------------------------

	for(i=1; i<=arrys; i++){
		L4d[i]=(double)L4[i*2-2]*(double)base+(double)L4[i*2-1];
	}
	
	disp_d(t, Digits, arrys, BaseDigits*2, 0);

}

//------------------------------------------------------------------------------ int version 3


void PICALC3()
{
	int  y[6000];

	int Digits,BaseDigits;
	int n, w, temp, c, base, g;
	int i, j, e, f, s, t, arrys;
	char buffer[21];
	unsigned int key=0;
	
	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PI INT calculation 3");
	Digits=InputDigits(1,2, 1000, 1800);
	if (Digits<0) return;
	BaseDigits=InputBaseDigits(1,3, 4, 5);
	if (BaseDigits<0) return;
	arrys=Digits/BaseDigits+1;
	if (ARRYS<arrys-1) goto ERR;
	
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();

	base=pow(10,BaseDigits);
	skip_count=0;

  	//  array initialize
//	for(i=0;i<=ARRYS;i++) {
//		L4[i]=0;
//	}
	
	s=RTC_GetTicks();	// --------------------------------------

  	//  loop counter
  	e = floor(log(10)/log(2)*BaseDigits);
  	f = floor(log(10)/log(2)*(Digits+1))+1;

	for(i=0;i<=f;i++) {
		y[i]=base/5;
	}

	c=0;
	n=f;
  	for(i=1; i<=arrys; i++) {
		temp=0;
		for(j=n-1; j>0; j--) {
			g=2*j-1;
			w=temp*j+y[j]*base;
			temp=(w/g);
			y[j]=w-temp*g;
		}

		w=(temp/base);
		L4[i]=c+w;
		c=temp-w*base;

		n=n-e;
	    
		s=disp_wait(n, f, s, t);
		if (s==0) return;

	};
	
	adjust_A_f(arrys,base);
	
	t=RTC_GetTicks()-s;	// --------------------------------------

	for(i=1; i<=arrys; i++){
		L4d[i]=(double)L4[i*2-1]*base+(double)L4[i*2];
	}
	
	disp_d(t, Digits, arrys, BaseDigits*2, 1);

}


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		locate(1,1);Print((unsigned char*)"F1:PICALC INT");
		locate(1,2);Print((unsigned char*)"F2:PICALC INT 2");
		locate(1,3);Print((unsigned char*)"F3:PICALC INT 3");
		
		locate(1,5);Print((unsigned char*)"F4:PICALC DBL");
		locate(1,6);Print((unsigned char*)"F5:PICALC DBL 2");
		locate(1,7);Print((unsigned char*)"F6:PICALC DBL 3");
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_F1:
				PICALC();			// algorithm 1
				break;
			case KEY_CTRL_F2:
				PICALC2();			// algorithm 2
				break;
			case KEY_CTRL_F3:
				PICALC3();			// spigot algorithm 3
				break;
			case KEY_CTRL_F4:
				PICALC_d();			// algorithm 1
				break;
			case KEY_CTRL_F5:
				PICALC2_d();		// algorithm 2
				break;
			case KEY_CTRL_F6:
				PICALC3_d();		// spigot algorithm 3
				break;
			case KEY_CTRL_VARS:
				InputTest();		// input test
				break;
			default:
				break;
		}
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

